
from wxPython.wx import *
import string


#try:
#    from xml.parsers.xmllib import *
#    fast = 1
#except:
    
# The xml-SIG parser lets "&" thru while the Python xmllib parser does not.
# So.. everybody got the python one, which means we have to have "&amp;"
# for the hotkeys instead of "&". Looks crappy, but waddayagonnado
from xmllib import *

# ========================================================================
class wxAppXmlMenuParser( XMLParser ):
    def __init__( self, app ):
	XMLParser.__init__( self )
	self.app = app
	self.curmenu = None
	self.menus = {}
	self.menubar = wxMenuBar()
	self.curname = None
	self.toolbar = None
	self.ids = {}
	
    # --------------------------------------------------------------------
    def start_wxappdef( self, attrs ):
	if attrs.has_key( 'statusbar' ):
	    self.app.CreateStatusBar()
	if attrs.has_key( 'title' ):
	    self.app.SetTitle( attrs['title'] )
	if attrs.has_key( 'wide' ) or attrs.has_key( 'high' ):
	    w = -1
	    h = -1
	    try:
		if attrs.has_key( 'wide' ):
		    w = int(attrs['wide'])
		if attrs.has_key( 'high' ):
		    h = int(attrs['high'])
		self.app.SetSize( wxSize( w, h ))
	    except:
		pass
	    
    # --------------------------------------------------------------------
    def end_wxappdef( self ):
	self.app.menubar = self.menubar
	self.app.toolbar = self.toolbar
	pass
	
    # --------------------------------------------------------------------
    def start_toolbar( self, attrs ):
	self.toolbar = wxToolBar( self.app, -1 )
    
    # --------------------------------------------------------------------
    def end_toolbar( self ):
	if self.toolbar:
	    self.app.SetToolBar( self.toolbar )
    
    # --------------------------------------------------------------------
    def start_toolbaritem( self, attrs ):
	if not self.toolbar:
	    return
	name = ''
	tip = ''
	bitmap = ''
	if attrs.has_key( 'name' ):
	    name = attrs['name']
	if attrs.has_key( 'bitmap' ):
	    bitmap = attrs['bitmap']
	if attrs.has_key( 'id' ):
	    id = int(attrs['id'])
	else:
	    id = wxNewId()
	if not name:
	    return
	if not bitmap:
	    return
	mname = string.replace( name, ' ', '' )
	self.toolbar.AddTool( id, wxBitmap( 'Images/%s.bmp' % mname, wxBITMAP_TYPE_BMP ),
	    shortHelpString=name )
	if hasattr( self.app, 'On' + mname ):
	    EVT_TOOL( self.app, id, getattr( self.app, 'On' + mname ))
	else:
	    # disable if method not found
	    self.toolbar.EnableTool( id, false )
	    
    # --------------------------------------------------------------------
    def end_toolbaritem( self ):
	pass
    
    # --------------------------------------------------------------------
    def start_toolbarseparator( self, attrs ):
	if self.toolbar:
	    self.toolbar.AddSeparator()
    
    # --------------------------------------------------------------------
    def end_toolbarseparator( self ):
	pass
    
    # --------------------------------------------------------------------
    # *** NEED to deal with submenus
    def start_menudef( self, attrs ):
	self.curmenu = None
	self.menus = {}
	self.menubar = wxMenuBar()
	self.curname = None
	self.ids = {}
    
    # --------------------------------------------------------------------
    # *** NEED to deal with submenus
    def end_menudef( self ):
	self.app.SetMenuBar( self.menubar )
	self.app.ids = self.ids
	for id in self.ids.keys():
	    if hasattr( self.app, 'On' + self.app.cleanCommand( self.ids[id]) ):
		EVT_MENU( self.app, id, getattr( self.app, 'On' + self.app.cleanCommand( self.ids[id] )))
	    else:
		# disbabled if method not found
		mi = self.menubar.FindItemById( id )
		mi.Enable( false )
		
    # --------------------------------------------------------------------
    def start_menu( self, attrs ):
	if attrs.has_key( 'name' ):
	    self.curname = attrs['name']
	self.curmenu = wxMenu()
	    
    # --------------------------------------------------------------------
    def end_menu( self ):
	self.menubar.Append( self.curmenu, self.curname )
	pass
    
    # --------------------------------------------------------------------
    def start_menuitem( self, attrs ):
	name = None
	accel = None
	tip = None
	if attrs.has_key( 'name' ):
	    name = attrs['name']
	if attrs.has_key( 'accel' ):
	    accel = attrs['accel']
	if attrs.has_key( 'tip' ):
	    tip = attrs['tip']	    
	if attrs.has_key( 'id' ):
	    id = int(attrs['id'])
	else:
	    id = wxNewId()
	if not name:
	    return
	mi = name
	if accel:
	    mi = mi + '\t' + accel
	if tip:
	    self.curmenu.Append( id, mi, tip ) 
	else:
	    self.curmenu.Append( id, mi, self.app.cleanCommand(name) ) 
	self.ids[id] = name
	    
    # --------------------------------------------------------------------
    def end_menuitem( self ):
	pass
        
    # --------------------------------------------------------------------
    def start_menuseparator( self, attrs ):
	self.curmenu.AppendSeparator()
	
    # --------------------------------------------------------------------
    def end_menuseparator( self ):
	pass
